#include "clocks.h"
#include "conf_core.h"

void clock_osc32k_init(void)
{
#if CORE_CONF_CLK_XOSC32K_ENABLE == 1
	OSC32KCTRL->XOSC32K.bit.CGM =		CORE_CONF_CLK_XOSC32K_CGM;
	OSC32KCTRL->XOSC32K.bit.WRTLOCK =	CORE_CONF_CLK_XOSC32K_WRTLOCK;
	OSC32KCTRL->XOSC32K.bit.STARTUP =	CORE_CONF_CLK_XOSC32K_STARTUP_TIME;
	OSC32KCTRL->XOSC32K.bit.RUNSTDBY =	CORE_CONF_CLK_XOSC32K_RUNSTDBY;
	OSC32KCTRL->XOSC32K.bit.ONDEMAND =	CORE_CONF_CLK_XOSC32K_ONDEMAND;
	OSC32KCTRL->XOSC32K.bit.EN1K =		CORE_CONF_CLK_XOSC32K_EN1K;
	OSC32KCTRL->XOSC32K.bit.EN32K =	CORE_CONF_CLK_XOSC32K_EN32K;
	OSC32KCTRL->XOSC32K.bit.XTALEN =	CORE_CONF_CLK_XOSC32K_XTALEN;
	OSC32KCTRL->CFDCTRL.bit.CFDPRESC =	CORE_CONF_CLK_XOSC32K_CFDPRESC;
	OSC32KCTRL->CFDCTRL.bit.SWBACK =	CORE_CONF_CLK_XOSC32K_SWBACK;
	OSC32KCTRL->CFDCTRL.bit.CFDEN =	CORE_CONF_CLK_XOSC32K_CFDEN;

#if CORE_CONF_CLK_XOSC32K_ENABLE == 1 && CORE_CONF_CLK_XOSC32K_ONDEMAND == 0
	while(OSC32KCTRL->STATUS.bit.XOSC32KRDY == 0);
#endif

#endif
}
void clock_osc_init(void)
{
#if CORE_CONF_CLK_XOSC0_ENABLE == 1
	OSCCTRL->XOSCCTRL[0].bit.XTALEN =			CORE_CONF_CLK_XOSC0_XTALEN;
	OSCCTRL->XOSCCTRL[0].bit.RUNSTDBY =		CORE_CONF_CLK_XOSC0_RUNSTDBY;
	OSCCTRL->XOSCCTRL[0].bit.ONDEMAND =		CORE_CONF_CLK_XOSC0_ONDEMAND;
	OSCCTRL->XOSCCTRL[0].bit.LOWBUFGAIN =		CORE_CONF_CLK_XOSC0_LOWBUFGAIN;
	OSCCTRL->XOSCCTRL[0].bit.IPTAT =			CORE_CONF_CLK_XOSC0_IPTAT;
	OSCCTRL->XOSCCTRL[0].bit.IMULT =			CORE_CONF_CLK_XOSC0_IMULT;
	OSCCTRL->XOSCCTRL[0].bit.ENALC =			CORE_CONF_CLK_XOSC0_ENALC;
	OSCCTRL->XOSCCTRL[0].bit.CFDEN =			CORE_CONF_CLK_XOSC0_CFDEN;
	OSCCTRL->XOSCCTRL[0].bit.CFDPRESC =		CORE_CONF_CLK_XOSC0_CFDPRESC;
	OSCCTRL->XOSCCTRL[0].bit.SWBEN =			CORE_CONF_CLK_XOSC0_SWBEN;
	OSCCTRL->XOSCCTRL[0].bit.STARTUP =			CORE_CONF_CLK_XOSC0_STARTUP_TIME;
	while(0 == OSCCTRL->STATUS.bit.XOSCRDY0);

#if CORE_CONF_CLK_XOSC0_ENALC == 1
	OSCCTRL->XOSCCTRL[0].bit.ENALC =			CORE_CONF_CLK_XOSC0_ENALC;
#endif

#if CORE_CONF_CLK_XOSC0_ONDEMAND == 1
	OSCCTRL->XOSCCTRL[0].bit.ONDEMAND =		CORE_CONF_CLK_XOSC0_ONDEMAND;
#endif

#endif

#if CORE_CONF_CLK_XOSC1_ENABLE == 1
	OSCCTRL->XOSCCTRL[1].bit.XTALEN =			CORE_CONF_CLK_XOSC1_XTALEN;
	OSCCTRL->XOSCCTRL[1].bit.RUNSTDBY =		CORE_CONF_CLK_XOSC1_RUNSTDBY;
	OSCCTRL->XOSCCTRL[1].bit.LOWBUFGAIN =		CORE_CONF_CLK_XOSC1_LOWBUFGAIN;
	OSCCTRL->XOSCCTRL[1].bit.IPTAT =			CORE_CONF_CLK_XOSC1_IPTAT;
	OSCCTRL->XOSCCTRL[1].bit.IMULT =			CORE_CONF_CLK_XOSC1_IMULT;
	OSCCTRL->XOSCCTRL[1].bit.CFDEN =			CORE_CONF_CLK_XOSC1_CFDEN;
	OSCCTRL->XOSCCTRL[1].bit.CFDPRESC =		CORE_CONF_CLK_XOSC1_CFDPRESC;
	OSCCTRL->XOSCCTRL[1].bit.SWBEN =			CORE_CONF_CLK_XOSC1_SWBEN;
	OSCCTRL->XOSCCTRL[1].bit.STARTUP =			CORE_CONF_CLK_XOSC1_STARTUP_TIME;
	while(0 == OSCCTRL->STATUS.bit.XOSCRDY1);

#if CORE_CONF_CLK_XOSC1_ENALC == 1
	OSCCTRL->XOSCCTRL[1].bit.ENALC =			CORE_CONF_CLK_XOSC1_ENALC;
#endif

#if CORE_CONF_CLK_XOSC1_ONDEMAND == 1
	OSCCTRL->XOSCCTRL[1].bit.ONDEMAND =		CORE_CONF_CLK_XOSC1_ONDEMAND;
#endif
#endif
}

void clock_mclk_init(void)
{

}

void clock_gclk_init(void)
{

}
